`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 21.02.2022 22:17:30
// Design Name: 
// Module Name: drawcon
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module drawcon(

    input [10:0] blkpos_x,
    input [10:0] blkpos_y,
    input [10:0] draw_x,
    input [10:0] draw_y,
    output [3:0] draw_r,
    output [3:0] draw_g,
    output [3:0] draw_b,
    output [11:0] collide_object 
    );
    
    reg [3:0] draw_r_r, draw_b_r, draw_g_r = 4'd0;
    reg [3:0] bg_r, bg_g, bg_b = 4'd0;
    reg [3:0] blk_r, blk_g, blk_b = 4'd0;
    reg [3:0] wall_r, wall_g, wall_b = 4'd0;
    reg [11:0] wall;
    reg [11:0] bg;
    reg [11:0] blk;
    
    always@* begin
            if((draw_x < 11'd10) || (draw_x > 11'd1430) || (draw_y < 11'd10) || (draw_y > 11'd890)) begin
            
                bg_r <= 4'b0000;
                bg_g <= 4'b0000;
                bg_b <= 4'b1111;
                
                bg <= {bg_r , bg_g , bg_b};
                
                draw_r_r <= bg_r;
                draw_g_r <= bg_g;
                draw_b_r <= bg_b;
            
            end
            
            else if((draw_x > 50) && (draw_x < 300) && (draw_y > 50) && (draw_y < 850))  begin
            
                wall_r <=4'b0000; 
                wall_g <=4'b0000;
                wall_b <=4'b1111;
                
                wall <= {wall_r , wall_g , wall_b};
                
                draw_r_r <= wall_r;
                draw_g_r <= wall_g;
                draw_b_r <= wall_b;
                
            end
            
            else if((draw_x > blkpos_x) && (draw_x < (blkpos_x + 11'd40)) && (draw_y > blkpos_y) && (draw_y < (blkpos_y + 11'd40)))  begin
            
                blk_r <=4'b1111; 
                blk_g <=4'b1111;
                blk_b <=4'b0000;
                
                blk <= {blk_r , blk_g , blk_b};
                
                draw_r_r <= blk_r;
                draw_g_r <= blk_g;
                draw_b_r <= blk_b;
            
            end
            
            else begin
            
                draw_r_r <= 4'b0000;
                draw_g_r <= 4'b0000;
                draw_b_r <= 4'b0000;
            
            end
    end
    
    
	//determine whether to draw block or bg
	
	assign draw_r = draw_r_r;
	assign draw_g = draw_g_r;
	assign draw_b = draw_b_r;
	
	assign collide_object = wall;
	
endmodule
