`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 21.02.2022 12:06:24
// Design Name: 
// Module Name: gametop
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module gametop(
        input clk,
        input [4:0] btn,
        output [3:0] pix_r,
        output [3:0] pix_g, 
        output [3:0] pix_b,
        output hsync, 
        output vsync
    );
    
    wire [10:0] curr_x;
    wire [10:0] curr_y;
    wire pixclk;    
//    reg [3:0] draw_r = 4'd0;
//    reg [3:0] draw_g = 4'd0;
//    reg [3:0] draw_b = 4'd0;  
    wire [3:0] draw_r;
    wire [3:0] draw_g;
    wire [3:0] draw_b;
    reg [10:0] blkpos_x = 11'd700;
    reg [10:0] blkpos_y = 11'd430;
    reg game_clk = 0;
    reg [20:0] clk_div = 0;
    
    wire collide_object;
    reg collision_right, collision_left, collision_top, collision_bottom = 1'b0;
    reg reset_collision = 1'b0;
  
  // Reset Collsion  
    always@(posedge pixclk) begin 
        if ((curr_y == 900) && (curr_x == 0)) begin 
        
            reset_collision <= 1'b1;
        
        end
        else begin
        
            reset_collision <= 1'b0;
        
        end
    end
    
    // Left Collision
    always@(posedge pixclk) begin 
        
        if (reset_collision == 1'b1) begin 
            
            collision_left <= 1'b0;
            
        end
        
        else if((draw_r == 4'b0000) && (draw_g == 4'b0000) && (draw_b == 4'b1111) && (curr_x <= blkpos_x) && (curr_y == blkpos_y + 11'd20)) begin
        
            collision_left <= 1'b1;
        
        end        
    end
    
    
    // Game clk
    always@(posedge clk) begin
        if(clk_div == 100000000/120) begin
            clk_div <= 20'd0;
            game_clk <= !game_clk;
        end
        else begin
            clk_div <= clk_div + 1;
            
        end
    end 
   wire update_blk = reset_collision;
     
    always@(posedge game_clk) begin
       if (update_blk == 1'b1) begin 
        
            if((collision_left == 1'b1)) begin
            
                if(btn[0]) begin
                    blkpos_x <= 11'd700;
                    blkpos_y <= 11'd430;
                end
                
                else begin
                    case(btn[4:1])
                        4'b0001: begin // UP
                            if(blkpos_y > 11'd10) begin
                                blkpos_y <= blkpos_y - 10;
                            end
                        end
                        
                        4'b0010: begin // LEFT
                            if(blkpos_x > 11'd10) begin
                                blkpos_x <= blkpos_x;
                            end
                        end
                        
                        4'b0100: begin // RIGHT
                            if(blkpos_x < 11'd1390) begin //
                                blkpos_x <= blkpos_x + 10;
                            end
                        end
                        
                        4'b1000: begin // DOWN
                            if(blkpos_y < 11'd850) begin //
                                blkpos_y <= blkpos_y + 10;
                            end
                        end
                        
                        default: begin // RETAINS CURRENT POS
                            blkpos_x <= blkpos_x;
                            blkpos_y <= blkpos_y;
                        end
                    endcase
                end
            end
        end
        
        else begin
        
            if(btn[0]) begin
                blkpos_x <= 11'd700;
                blkpos_y <= 11'd430;
            end
            else begin
                case(btn[4:1])
                    4'b0001: begin // UP
                        if(blkpos_y > 11'd10) begin
                            blkpos_y <= blkpos_y - 10;
                        end
                    end
                    
                    4'b0010: begin // LEFT
                        if(blkpos_x > 11'd10) begin
                            blkpos_x <= blkpos_x - 10;
                        end
                    end
                    
                    4'b0100: begin // RIGHT
                        if(blkpos_x < 11'd1390) begin //
                            blkpos_x <= blkpos_x + 10;
                        end
                    end
                    
                    4'b1000: begin // DOWN
                        if(blkpos_y < 11'd850) begin //
                            blkpos_y <= blkpos_y + 10;
                        end
                    end
                                    
                    default: begin // RETAINS CURRENT POS
                        blkpos_x <= blkpos_x;
                        blkpos_y <= blkpos_y;
                    end
                endcase
            end
        end    	
	end
        
    
    clk_wiz_0 inst
    (
    // Clock out ports
    .clk_out1(pixclk),
    // Clock in ports
    .clk_in1(clk)
    );
    
    vga inst_1(
        .clk(pixclk),
        .pix_r(pix_r),
        .pix_g(pix_g),
        .pix_b(pix_b),
        .hsync(hsync),
        .vsync(vsync),
        .curr_x(curr_x),
        .curr_y(curr_y), 
        .draw_r(draw_r),
        .draw_g(draw_g),
        .draw_b(draw_b)
        );
        
    drawcon inst_2 (
		.blkpos_x(blkpos_x),
		.blkpos_y(blkpos_y),
		.draw_x(curr_x),
		.draw_y(curr_y),
		.draw_r(draw_r),
		.draw_g(draw_g),
		.draw_b(draw_b),
		.collide_object(collide_object)
		);
        
endmodule
